#include <gtk/gtk.h>
#include <stdlib.h>

GtkWidget* entry_upper;
GtkWidget* entry_lower;
GtkWidget* entry_center;
GtkWidget* check_real;

void entry_changed(GtkWidget *widget,gpointer user_data) {
	int error=0;
	double upper_d;
	double lower_d;
	double center_d;
	long long upper_l;
	long long lower_l;
	long long center_l;
	char result[1000];
	char* end;
	if(GTK_TOGGLE_BUTTON(check_real)->active) {
		//実数
		upper_d=strtod(gtk_entry_get_text(GTK_ENTRY(entry_upper)),&end);
		if(*end!=0)error=1;
		lower_d=strtod(gtk_entry_get_text(GTK_ENTRY(entry_lower)),&end);
		if(*end!=0)error=1;
		if(!error) {
			center_d=(upper_d+lower_d)/2.0;
			sprintf(result,"%g",center_d);
			gtk_entry_set_text(GTK_ENTRY(entry_center),result);
		} else {
			gtk_entry_set_text(GTK_ENTRY(entry_center),"エラー");
		}
	} else {
		//整数
		upper_l=strtoll(gtk_entry_get_text(GTK_ENTRY(entry_upper)),&end,10);
		if(*end!=0)error=1;
		lower_l=strtoll(gtk_entry_get_text(GTK_ENTRY(entry_lower)),&end,10);
		if(*end!=0)error=1;
		if(!error) {
			center_l=(upper_l+lower_l)/2;
			sprintf(result,"%lld",center_l);
			gtk_entry_set_text(GTK_ENTRY(entry_center),result);
		} else {
			gtk_entry_set_text(GTK_ENTRY(entry_center),"エラー");
		}
	}
}

void upper_button_clicked(GtkWidget *button, gpointer user_data) {
	gtk_entry_set_text(GTK_ENTRY(entry_upper),
		gtk_entry_get_text(GTK_ENTRY(entry_center)));
}

void lower_button_clicked(GtkWidget *button, gpointer user_data) {
	gtk_entry_set_text(GTK_ENTRY(entry_lower),
		gtk_entry_get_text(GTK_ENTRY(entry_center)));
}

void makegui(GtkWidget *window) {
	GtkWidget* table;
	GtkWidget* label_upper;
	GtkWidget* button_upper;
	GtkWidget* button_lower;
	GtkWidget* label_center;
	GtkWidget* label_lower;
	//テーブルを作成
	table=gtk_table_new(6,4,TRUE);
	gtk_container_add(GTK_CONTAINER(window),table);
	//上限のテキスト
	label_upper=gtk_label_new("上限");
	entry_upper=gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(entry_upper),"0");
	g_signal_connect (G_OBJECT(entry_upper), "changed" ,
		G_CALLBACK(entry_changed), NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),label_upper,0,1,0,1);
	gtk_table_attach_defaults(GTK_TABLE(table),entry_upper,1,4,0,1);
	//上限ボタン
	button_upper=gtk_button_new_with_label("求める値は中央値より小さい");
	gtk_table_attach_defaults(GTK_TABLE(table),button_upper,1,4,1,2);
	g_signal_connect (G_OBJECT(button_upper),"clicked",
		G_CALLBACK(upper_button_clicked),NULL);
	//中央値のテキスト
	label_center=gtk_label_new("中央値");
	entry_center=gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(entry_center),"0");
	gtk_entry_set_editable(GTK_ENTRY(entry_center),FALSE);
	gtk_table_attach_defaults(GTK_TABLE(table),label_center,0,1,2,3);
	gtk_table_attach_defaults(GTK_TABLE(table),entry_center,1,4,2,3);
	//下限ボタン
	button_lower=gtk_button_new_with_label("求める値は中央値より大きい");
	gtk_table_attach_defaults(GTK_TABLE(table),button_lower,1,4,3,4);
	g_signal_connect (G_OBJECT(button_lower),"clicked",
		G_CALLBACK(lower_button_clicked),NULL);
	//下限のテキスト
	label_lower=gtk_label_new("下限");
	entry_lower=gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(entry_lower),"0");
	g_signal_connect (G_OBJECT(entry_lower), "changed" ,
		G_CALLBACK(entry_changed), NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),label_lower,0,1,4,5);
	gtk_table_attach_defaults(GTK_TABLE(table),entry_lower,1,4,4,5);
	//整数・実数切り替え
	check_real=gtk_check_button_new_with_label("実数モード");
	g_signal_connect (G_OBJECT(check_real), "toggled" ,
		G_CALLBACK(entry_changed), NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),check_real,0,4,5,6);
}

int main(int argc, char** argv){
	GtkWidget *window;

	//gtkを初期化する。おまじない。
	gtk_init(&argc,&argv);

	//ウインドウウィジェットを作成する。
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

	//ウインドウの大きさを指定
	gtk_widget_set_size_request(window,300,200);
	
	//ウインドウのタイトルを指定
	gtk_window_set_title((GtkWindow*)window,"二分探索支援ソフト");
	
	//ウィンドウをリサイズできなくする
	gtk_window_set_resizable((GtkWindow*)window,FALSE);
 
	//ウインドウを閉じるときにプログラムも終了する。
	g_signal_connect(window, "destroy",
		G_CALLBACK(gtk_main_quit), NULL);
 
 	//GUIを作成
 	makegui(window);
 
	//ウインドウを表示
	gtk_widget_show_all(window);
 
	gtk_main();
 
	return 0;
}
